<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "355, 355, 359, 365, 400, 427, 429, 430, 431, 432, 433, 434, 435, 554, 798, 1872"
strThisBackPage = "config" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

CFGC_ID = NumSafe(DualRequest("CFGC_ID"))
strConfigName = DualRequest("strConfigName")

'-----------------------------------------------
'UDPATE VALUES
'-----------------------------------------------
If request.Form("update") <> "" then
	aryNames = Split(Request.Form("strNames"), ", ")
	For Each CFG_Name in aryNames
		'Get information
		CFG_DataType = Request.Form(CFG_Name & "_CFG_DataType")
		CFG_DisplayType = Request.Form(CFG_Name & "_CFG_DisplayType")
		CFG_Value = Request.Form(CFG_Name & "_CFG_Value")
		
		'Ensure data is valid
		Select Case CFG_DisplayType
			Case "m": CFG_Value = Replace(CFG_Value, ", ", ",")
			Case "b": CFG_Value = ListSafe(CFG_Value, "y,n", "n")
		End Select
		If CFG_DataType = "n" Then
			CFG_Value = NumSafe(CFG_Value)
		End if
		
		'Update
		strQuery = "UPDATE tblCactuShop" & TABLE_PREFIX & "Config SET CFG_Value=" & strUnicode & "'" & SQLSafe(CFG_Value) & "' WHERE CFG_Name = " & strUnicode & "'" & SQLSafe(CFG_Name) & "'"
		blnUpdated = true
		Call ExecuteNonQuery(strQuery)
		AdminLog "c", GetString("AdminLog_ConfigChange"), strQuery, CFG_Name	
		
	Next
	
	'If we're updated, redirect. This allows appvars to reset,
	'and to stop refreshes resubmitting the data
	Call EndPage()
	response.Redirect("_config_list.asp?" & strSessionQS & "CFGC_ID=" & CFGC_ID & "&strConfigName=" & URLSafe(strConfigName) & "&appvar=reset")
End If


'-----------------------------------------------
'LIST CONFIG VALUES								
'-----------------------------------------------
If CFGC_ID <> 0 then
	strWhereClause = " WHERE CFG_ConfigCategoryID=" & CFGC_ID
Else
	strWhereClause = " WHERE CFG_Name='" & SQLSafe(strConfigName) & "'"
End if

strQuery = "SELECT CFG_Name, CFG_Value, CFG_DataType, CFG_DisplayType, CFG_DisplayInfo, CFG_Description, cc.CFGC_Category As ChildCategory, ccp.CFGC_Category As ParentCategory FROM (tblCactuShop" & TABLE_PREFIX & "Config c INNER JOIN tblCactuShop" & TABLE_PREFIX & "ConfigCategories cc ON c.CFG_ConfigCategoryID = cc.CFGC_ID) INNER JOIN tblCactuShop" & TABLE_PREFIX & "ConfigCategories ccp ON cc.CFGC_ParentID = ccp.CFGC_ID " & strWhereClause & " ORDER BY CFG_Name"
Call ExecuteRS(strQuery, objRecordSet)
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
	<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="660">
<tr>
    <td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
    <td valign="top"><form action="_config_list.asp" method="post">
	<%= objCactuSession.Form %>
	<input type="hidden" name="CFGC_ID" value="<%= CFGC_ID %>" />
	<input type="hidden" name="strConfigName" value="<%= WriteSafe(strConfigName) %>" />
    <table border="0" cellpadding="5" cellspacing="0" width="100%">
		<tr>
			<td><h1><% WriteString("PageTitle_ConfigListing") %></h1></td>
		</tr>
		<tr>
			<td class="small"><a href="_config_category.asp?<%= objCactuSession.QS %>"><% WriteString("ContentText_BackToCategories") %></a></td>
		</tr>
		<% If request.QueryString("appvar") = "reset" then %>
			<tr>
				<td colspan="4" class="bold highlight"><% WriteString("ContentText_ConfigAppVariablesRebuilt") %></td>					
			</tr>
		<% end if %>		
		<tr><td><table border="0" cellpadding="3" cellspacing="0" width="100%">
			<% 
			strLastCategory = ""
			do while not objRecordSet.EOF
				CFG_Name = objRecordSet("CFG_Name")
				CFG_Value = objRecordSet("CFG_Value")
				CFG_DataType = objRecordSet("CFG_DataType")
				CFG_DisplayType = objRecordSet("CFG_DisplayType")
				CFG_DisplayInfo = objRecordSet("CFG_DisplayInfo")
				CFG_Description = objRecordSet("CFG_Description")
				strCategory = objRecordset("ChildCategory")
				strParent = objRecordSet("ParentCategory")
				strFullCategoryName = strParent & " &#187; " & strCategory
				'Write out header if new
				If strFullCategoryName <> strLastCategory then %>
					<tr>
						<td colspan="2"><strong><%= strFullCategoryName %></strong></td>
						<tr>
							<td class="small bold dull" width="20%"><% WriteString("ContentText_AppVariable") %></td>
							<td class="small bold dull" width="70%"><% WriteString("ContentText_Value") %></td>
						</tr>	
					</tr><%
				end if
				
				'Write out the config setting %>
				<input type="hidden" name="strNames" value="<%= CFG_Name %>" />
				<input type="hidden" name="<%= CFG_Name %>_CFG_DataType" value="<%= CFG_DataType %>" />
				<input type="hidden" name="<%= CFG_Name %>_CFG_DisplayType" value="<%= CFG_DisplayType %>" />
				<tr bgcolor="#dddddd">
					<td class="small bold"><%= CFG_Name %></td>
					<td class="small"><% 
						'Special displays
						Select Case CFG_Name
							Case "defaultlanguage" 
								'Display dropdown of languages 
								strQuery = "SELECT LANG_ID, LANG_FrontName FROM tblCactuShop" & TABLE_PREFIX & "Languages WHERE LANG_LiveFront = 'y' ORDER BY LANG_ID ASC"
								Call ExecuteRS(strQuery, objRecordSet2)	
								Call SingleDropDown(CFG_Name & "_CFG_Value", "", "", objRecordSet2, "LANG_ID", "LANG_FrontName", NumSafe(CFG_Value))
								objRecordSet2.Close

							Case "defaultcountry" 
								'Display dropdown of destinations
								strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "Destination WHERE D_Live='y' ORDER BY D_Destination" & CInt(numLanguageID)
								Call ExecuteRS(strQuery, objRecordSet2)
								Call SingleDropDown(CFG_Name & "_CFG_Value", "", "", objRecordSet2, "D_ID", "D_Destination" & CInt(numLanguageID), NumSafe(CFG_Value))
								objRecordSet2.Close
								
							Case "shiptaxband", "orderhandlingchargetaxband"
								'Display dropdown for tax rates
								strQuery = "SELECT T_ID, T_TaxRate FROM tblCactuShop" & TABLE_PREFIX & "TaxRates ORDER BY T_ID"
								Call ExecuteRS(strQuery, objRecordSet2) %>
								<select name="<%= CFG_Name %>_CFG_Value"><%
									Do While not objRecordSet2.EOF
										T_ID = objRecordSet2("T_ID")
										strText = GetString("FormLabel_TaxBand") & " " & T_ID & " (" & objRecordSet2("T_Taxrate") & "%)" %>
										<option value="<%= T_ID %>"<%= IIf(T_ID & "" = CFG_Value, " selected=""selected""", "") %>><%= strText %></option><%
										objRecordSet2.MoveNext
									Loop
									objRecordSet2.Close %>
								</select><%
																
							Case Else 
								'Normal display
								Select Case CFG_DisplayType
									Case "t", "n", "l"
										'Normal text box - numbers are smaller %>
										<input size="<%= IIf(CFG_DisplayType = "n", "5", "35") %>" type="text" name="<%= CFG_Name %>_CFG_Value" value="<%= WriteSafe(CFG_Value) %>" />
										
									<% Case "b" 
										'Boolean value - show checkbox %>
										<input type="checkbox" name="<%= CFG_Name %>_CFG_Value" value="y"<%= IIf(CFG_Value = "y", " checked=""checked""", "") %> />
										
									<% Case "s", "m"
										'Select box - either single or multi %>
										<select name="<%= CFG_Name %>_CFG_Value" size="<%= IIf(CFG_DisplayType = "m", "10", "1") %>"<%= IIf(CFG_DisplayType = "m", " multiple=""multiple""", "") %> />
											<%
											aryDisplayInfo = Split(CFG_DisplayInfo & "", "|")
											For Each strDisplayInfo in aryDisplayInfo
												blnSelected = Contains(lcase(CFG_Value), lcase(strDisplayInfo)) %>
												<option value="<%= strDisplayInfo %>"<%= IIf(blnSelected, " selected=""selected""", "") %>><%= strDisplayInfo %></option>
											<% Next %>
										</select><%
								End select 
						End Select %>			
					</td>
				</tr>
				<tr bgcolor="#eeeeee">	
					<td colspan="2" class="small"><%= CFG_Description %><%
						'Special displays
						Select Case CFG_Name
							Case "timeoffset" %>
								<br />Server Time: <%= now %><% if CFG_Value > 0 then %>
								<br />Offset of <%= CFG_Value %>: <%= DateAdd("h", CFG_Value, now) %><%
								end if
								
							Case "webshopurl", "webshopfolder"
								'Get the WebShopURL and folder
								On error resume next
								strServerName = "http://" & request.ServerVariables("SERVER_NAME")
								strScriptName = Replace(request.ServerVariables("SCRIPT_NAME"), "_config_list.asp", "")
								strWebShopURL = strServerName & strScriptName	
								numDomainEndPos = 1
								For i = 1 to 3
									numDomainEndPos = instr(numDomainEndPos + 1, strWebShopURL, "/")
								Next
								strWebShopFolder = mid(strWebShopURL, numDomainEndPos + 1)
								If Right(strWebShopFolder, 1) <> "/" then strWebShopFolder = strWebShopFolder & "/"
								If strWebShopFolder = "/" then strWebShopFolder = ""
								
								response.Write "<br />" & GetString("ContentText_ThisIsCurrently")
								If CFG_Name = "webshopurl" then
									response.Write strWebShopURL
								Else
									response.Write strWebShopFolder
								End If
								On error goto 0
								
						End Select %>
					</td>
				</tr>
				<%
				strLastCategory = strFullCategoryName
				objRecordSet.MoveNext
			loop
			objRecordSet.Close %>	
			<tr>
				<td colspan="2" align="right"><input type="submit" name="update" value="<% WriteSafeString("FormButton_Update") %>" /></td>
			</tr>	
		</table></td></tr>
		
	</table></form><br /><br /></td>
</tr>
</table>
</body>
</html>
<%
Call EndPage()
%>
