<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "359, 401, 402, 518, 531, 532, 533, 570, 574, 585, 1364, 1431, 1432, 1433, 1434, 1435, 1436, 1663"
strThisBackPage = "products" 
Set Uploader = New FileUploader
Uploader.Upload()
%>
<!--#include file="includes/upload.asp"-->
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/functions_backend.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'IMPORTANT NOTE: This page handles forms
'differently. The form is multipart encoded to
'allow file upload. Therefore we need to use the
'Upload Object. This requires VBScript5 support
'on server (get from Microsoft or Install IE5 on
'the server).
'-----------------------------------------------

'-----------------------------------------------
'UPDATE PRODUCTS
'This page updates a product with the details
'specified in the modify_products.asp form.
'-----------------------------------------------

'-----------------------------------------------
'COLLECT VALUES FROM FORM						
'-----------------------------------------------
P_ID = Uploader.Form("P_ID")
CAT_ID = Uploader.Form("CAT_ID")

strCallMode = Uploader.Form("strCallMode")
P_DeleteImage = Uploader.Form("P_DeleteImage")
P_DeleteImage_Large = Uploader.Form("P_DeleteImage_Large")


Dim P_Name(), P_StrapLine(), P_Desc(), P_SpecTable(), P_Hyperlink()
Redim P_Name(numTotalLanguages)
Redim P_Desc(numTotalLanguages)
Redim P_StrapLine(numTotalLanguages)
Redim P_SpecTable(numTotalLanguages)
Redim P_Hyperlink(numTotalLanguages)
For numCount = 1 to numTotalLanguages
	P_Name(numCount) = Uploader.Form("P_Name" & CStr(numCount))
	P_Desc(numCount) = Uploader.Form("P_Desc" & CStr(numCount))
	P_StrapLine(numCount) = Uploader.Form("P_StrapLine" & CStr(numCount))
	P_SpecTable(numCount) = Uploader.Form("P_SpecTable" & CStr(numCount))
	P_Hyperlink(numCount) = Uploader.Form("P_Hyperlink" & CStr(numCount))
next

P_ProdType = Uploader.Form("P_ProdType")
P_Featured = Uploader.Form("P_Featured")
P_Live = Uploader.Form("P_Live")
P_Categories = Uploader.Form("P_Categories")
P_VersionDisplayType = Uploader.Form("P_VersionDisplayType")
P_Reviews = Uploader.Form("P_Reviews")
P_SupplierID = NumSafe(Uploader.Form("P_SupplierID"))
P_Type = Uploader.Form("P_Type")
SUP_Name = Uploader.form("SUP_Name")
P_CustomerGroupID = NumSafe(Uploader.Form("P_CustomerGroupID"))

strGotVersions = Uploader.Form("strGotVersions")
strGotOptions = Uploader.Form("strGotOptions")

'If text has been supplied, then used that - so 
'wipe the supplier ID
If SUP_Name <> "" then P_SupplierID = 0

If P_Live = "" Then P_Live = "n"

P_OrderByValue = Uploader.Form("P_OrderByValue")
If Not IsNumeric(P_OrderByValue) then P_OrderByValue = 0

P_OrderVersionsBy = Uploader.Form("P_OrderVersionsBy")

If strCallMode = "Delete" Then
	'User wants to delete this Version
	Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
	DeleteProduct P_ID, objFileSystem, objRecordSet
	Set objFileSystem = Nothing
	strErrorMsg = ""
Else
	'-------------------------------------------
	'CHECK FILE UPLOAD IS OK FILETYPE
	'-------------------------------------------
	If Uploader.Files.Exists("P_Image") Then
		strFileUploadName = Uploader.Files("P_Image").FileName
		If Not strFileUploadName = "" Then
			aryFileUploadName = Split(strFileUploadName, ".")
			strFileType = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
		End If
		If Not Contains(GetAppVar("allowedimages"), strFileType) Then
			numErrorNo = numErrorNo + 1
			strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
		End If
	End If
	If Uploader.Files.Exists("P_Image_Large") Then
		strFileUploadName = Uploader.Files("P_Image_Large").FileName
		If Not strFileUploadName = "" Then
			aryFileUploadName = Split(strFileUploadName, ".")
			strFileType_Large = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
		End If
		If Not Contains(GetAppVar("allowedimages"), strFileType_Large) Then
			numErrorNo = numErrorNo + 1
			strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
		End If
	End If

	'-------------------------------------------
	'PERFORM REST OF ERROR CHECKING
	'-------------------------------------------
	strAllNamesBlank = true
	strAllDescsBlank = true
	For numCount = 1 to numTotalLanguages
		'If it's live on the front, then it needs to be checked for blanks
		If aryLangLiveFront(numCount) = "y" then
			strAllNamesBlank = strAllNamesBlank and P_Name(numCount) = ""
			strAllDescsBlank = strAllDescsBlank and P_Desc(numCount) = ""
		end if
		
		'Check them all for string length
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_Title") & " " & cstr(numCount), P_Name(numCount), GetAppVar("P_Name_AL"))
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_StrapLine") & " " & cstr(numCount), P_StrapLine(numCount), GetAppVar("P_StrapLine_AL"))
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_Description") & " " & cstr(numCount), P_Desc(numCount), GetAppVar("P_Desc_AL"))
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_Specifications") & " " & cstr(numCount), P_SpecTable(numCount), GetAppVar("P_SpecTable_AL"))
	next

	'if all names or all descriptions are blank,  then add on the error
	If strAllNamesBlank then strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_Title"), "")
	'If strAllDescsBlank then strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_Description"), "")
	strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_Supplier"), SUP_Name, GetAppVar("SUP_Name_AL"))
	
	If P_Categories = "" Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + Cstr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkProductLink") & "<br />"
	End If

	'Error Checking Complete
	If strErrorMsg = "" Then
	
		'Clean the categories and remove duplicates. Duplicates occur because a category
		'in multiple parents can be selected more than once. But we only need one link record
		P_Categories = replace(P_Categories, " ", "")
		aryCategories = Split(P_Categories, ",")
		For Each strCategory in aryCategories
			numCategory = NumSafe(strCategory)
			If Not Contains(strCategories, numCategory) then
				If strCategories = "" then
					strCategories = numCategory
				Else
					strCategories = strCategories & "," & numCategory
				End If
			End If
		Next
		aryCategories = Split(strCategories, ",")
		
		'If a new supplier is being added, check first that's it's not being used
		If SUP_Name <> "" then
			strQuery = "SELECT SUP_ID FROM tblCactuShop" & TABLE_PREFIX & "Suppliers WHERE SUP_Name = " & strUnicode & "'" & SQLSafe(SUP_Name) & "'"
			Call ExecuteRS(strQuery, objRecordSet)
			If not (objRecordSet.BOF and objRecordSet.EOF) then
				P_SupplierID = objRecordSet("SUP_ID")
			End if
			objRecordSet.Close
			
			'Still don't have a supplier id? Then add it and get the ID
			If P_SupplierID = 0 then
				strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "Suppliers (SUP_Name, SUP_Live) VALUES (" & strUnicode & "'" & SQLSafe(SUP_Name) & "', 'y')"
				Call ExecuteNonQuery(strQuery)
				Do While P_SupplierID = 0
					strQuery = "SELECT SUP_ID FROM tblCactuShop" & TABLE_PREFIX & "Suppliers WHERE SUP_Name = " & strUnicode & "'" & SQLSafe(SUP_Name) & "'"
					Call ExecuteRS(strQuery, objRecordSet)
					If not (objRecordset.BOF And objRecordSet.EOF) then
						P_SupplierID = objRecordSet("SUP_ID")
					end if
					objRecordSet.Close
				Loop
			end if
		end if
		
		'No problem with doing the database stuff
		'-----------------------------------------------
		'NEW PRODUCT
		'If P_ID is zero then it is a new product, in
		'this case we insert a new record into the DB
		'-----------------------------------------------
		If P_ID = 0 Then
			strQuery="INSERT INTO tblCactuShop" & TABLE_PREFIX & "Products ("
			For numCount = 1 to numTotalLanguages
				If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & "P_Name" & CStr(numCount) & ", P_Desc" & CStr(numCount) & ", P_StrapLine" & CStr(numCount) & ", P_SpecTable" & CStr(numCount) & ", P_Hyperlink" & CStr(numCount) & ","
			next
			strQuery=strQuery & "P_Featured,P_OrderByValue,P_OrderVersionsBy,P_Live,P_VersionDisplayType,P_Reviews,P_SupplierID,P_Type,P_CustomerGroupID) VALUES("
			For numCount = 1 to numTotalLanguages
				If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & strUnicode & "'" & SQLSafe(P_Name(numCount)) & "', " & strUnicode & "'" & SQLSafe(P_Desc(numCount)) & "', " & strUnicode & "'" & SQLSafe(P_StrapLine(numCount)) & "', " & strUnicode & "'" & SQLSafe(P_SpecTable(numCount)) & "', " & strUnicode & "'" & P_Hyperlink(numCount) & "',"
			next
			strQuery = strQuery &_
				P_Featured & "," &_
				P_OrderByValue & ",'" &_
				SQLSafe(P_OrderVersionsBy) & "','" &_
				SQLSafe(P_Live) & "','" &_
				SQLSafe(P_VersionDisplayType) & "','" &_
				SQLSafe(P_Reviews) & "'," &_
				P_SupplierID & ",'" &_
				SQLSafe(P_Type) & "'," &_
				P_CustomerGroupID & ")"
			Call ExecuteNonQuery(strQuery)

			'--------------------------------------------------
			'FIND ID OF NEW PRODUCT
			'--------------------------------------------------
			strQuery = "SELECT P_ID, P_Name" & CInt(numLanguageID) & " FROM tblCactuShop" & TABLE_PREFIX & "Products WHERE P_Name" & CInt(numLanguageID) & "=" & strUnicode & "'" & SQLSafe(P_Name(numLanguageID)) & "' ORDER BY P_ID DESC"
			Call ExecuteRS(strQuery, objRecordSet)
			P_ID = objRecordSet("P_ID")
			objRecordSet.close

		'-----------------------------------------------
		'UPDATE PRODUCT
		'Otherwise, update the product.
		'-----------------------------------------------
		Else
			'Get the product customer review average
			P_AverageRating = GetProductAverage(P_ID)
			
			'Update
			strQuery="UPDATE tblCactuShop" & TABLE_PREFIX & "Products SET "
			for numCount = 1 to numTotalLanguages
				If arylangliveback(numCount) = "y" then strQuery = strQuery & "P_Name" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(P_Name(numCount)) & "',P_Desc" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(P_Desc(numCount)) & "',P_StrapLine" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(P_StrapLine(numCount)) & "',P_SpecTable" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(P_SpecTable(numCount)) & "',P_Hyperlink" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(P_Hyperlink(numCount)) & "',"
			next
			strQuery = strQuery &_
				"P_Featured=" & P_Featured & "," &_
				"P_OrderByValue=" & P_OrderByValue & "," &_
				"P_OrderVersionsBy='" & SQLSafe(P_OrderVersionsBy) & "'," &_
				"P_Live='" & SQLSafe(P_Live) & "'," &_
				"P_VersionDisplayType='" & SQLSafe(P_VersionDisplayType) & "'," &_
				"P_Reviews='" & SQLSafe(P_Reviews) & "'," &_
				"P_SupplierID=" & P_SupplierID & "," &_
				"P_Type='" & SQLSafe(P_Type) & "', " &_
				"P_CustomerGroupID=" & P_CustomerGroupID & ", " &_
				"P_AverageRating=" & P_AverageRating &_
				" WHERE P_ID=" & P_ID
			Call ExecuteNonQuery(strQuery)
			
			
		End If

		'Do the image management, if needed
		'Use Product ID + File Extension for name to avoid overwriting pre-existing images.
		Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
		If P_DeleteImage = "y" Or Uploader.Files.Exists("P_Image") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_products/" & P_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
		If P_DeleteImage_Large = "y" Or Uploader.Files.Exists("P_Image_Large") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_products_large/" & P_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
		Set objFileSystem = Nothing
		If Uploader.Files.Exists("P_Image") Then
			Uploader.Files("P_Image").FileName = P_ID & "." & strFileType
			Uploader.Files("P_Image").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_products/")
		End If
		If Uploader.Files.Exists("P_Image_Large") Then
			Uploader.Files("P_Image_Large").FileName = P_ID & "." & strFileType_Large
			Uploader.Files("P_Image_Large").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_products_large/")
		End If
		
		'Update Product category links and attribute values
		ProductCategories P_ID, aryCategories
		If SOFTWARE_IS_PRO then
			ProcessProductAttributes P_ID
		End If

	End If
End If

%>

<!--#include file="includes/back_productpage.asp"-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
	<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="660">
<tr>
    <td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
    <td valign="top">
    <%= strProductHTML %>
    <table border="0" cellpadding="5" cellspacing="0" width="100%">
	<% if strErrorMsg <> "" then 
		'Show errors %>
		<tr>
			<td><h1><% WriteString("PageTitle_Problems") %></h1></td>
		</tr>
		<tr>
			<td><% WriteString("ContentText_PleaseGoBackAndCorrect") %></td>
		</tr>
		<tr>
			<td><% =strErrorMsg %></td>
		</tr>	
		<tr>
			<td align="center"><a href="javascript:history.back()">&#171; <% WriteString("ContentText_BackLink") %></a></td>
		</tr>	 
		
	<% elseif strGotVersions = "y" or strGotOptions = "y" then
		'Tell the user all was good %>
		<tr>
			<td><h1><% WriteString("PageTitle_Updated") %></h1></td>
		</tr>		
		<tr>
			<td><% WriteString("ContentText_ProductUpdated") %></td>
		</tr>
	
	<% elseif strCallMode = "Delete" then %>
		<tr>
			<td><h1><% WriteString("PageTitle_Updated") %></h1></td>
		</tr>		
		<tr>
			<td><% WriteString("ContentText_ProductDeleted") %></td>
		</tr>
		<% If CAT_ID > 0 then %>
			<tr><td class="small"><a href="_prodtype_back.asp?<%= objCactuSession.QS %>CAT_ID=<%= CAT_ID %>"><% WriteString("ContentText_BackToLink") %> <%= strProdtypeName %></a></span></td></tr>
		<% end if %>
	
	
	<% else
		
		'Tell the user they were successful, give them option based on product type 
		select case P_Type
			case "s"
				strText = GetString("ContentText_NowAddSingleVersion")
				strURL = "_modify_version.asp?" & objCactuSession.QS & "single=y&V_ID=0&amp;P_ID=" & P_ID & "&amp;CAT_ID=" & CAT_ID
				strURLText = GetString("ContentText_LinkAddSingleVersion")
		
			case "m"
				strText = GetString("ContentText_NowAddMultipleVersion")
				strURL = "_modify_version.asp?" & objCactuSession.QS & "V_ID=0&amp;P_ID=" & P_ID & "&amp;CAT_ID=" & CAT_ID
				strURLText = GetString("ContentText_LinkAddSingleVersion")
				
			case "o"
				strText = GetString("ContentText_NowAssignOptions")
				strURL = "_combinations_set.asp?" & objCactuSession.QS & "P_ID=" & P_ID & "&amp;CAT_ID=" & CAT_ID
				strURLText = GetString("ContentText_LinkAssignOptions")
		End Select	
		%>
		<tr>
			<td><h1><% WriteString("PageTitle_Updated") %></h1></td>
		</tr>
		<tr>
			<td><%= strText %></td>
		</tr>
		<tr>
			<td><a href="<%= strURL %>"><%= strURLText %></a></td>
		</tr>
	<% end if %>
	</table></td>
	</tr>
</table>
</div>
</html>
<%
Call EndPage()
%>
