<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "359, 401, 402, 532, 549, 550, 551, 570, 579, 580, 581, 582, 583, 584, 585, 586, 587, 588, 864, 1235, 1437, 1489"
strThisBackPage = "products" 
Set Uploader = New FileUploader
Uploader.Upload()
%>
<!--#include file="includes/upload.asp"-->
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/functions_backend.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'IMPORTANT NOTE: This page handles forms
'differently. The form is multipart encoded to
'allow file upload. Therefore we need to use the
'Upload Object. This requires VBScript5 support
'on server (get from Microsoft or Install IE5 on
'the server).
'-----------------------------------------------

'-----------------------------------------------
'UPDATE VERSION
'This page updates the version of a product with
'the details specified in the modify_verson.asp
'form.
'-----------------------------------------------

'-----------------------------------------------
'FUNCTION: CHECK IF VERSION CODE IS ALREADY IN
'USE
'-----------------------------------------------
Function CheckVersionCode(numVersionCode, numVersion)
	strQuery = "SELECT V_ID FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_CodeNumber = " & strUnicode & "'" & SQLSafe(numVersionCode) & "' AND NOT V_ID = " & numVersion
	Call ExecuteRS(strQuery, objRecordSet)
	If objRecordSet.RecordCount < 1 Then
		CheckVersionCode = "OK"
	Else
		CheckVersionCode = objRecordSet(0)
	End If
	objRecordSet.Close
End Function

'-----------------------------------------------
'COLLECT VALUES FROM FORM						
'-----------------------------------------------
CAT_ID = Uploader.Form("CAT_ID")
strCallMode = Uploader.Form("strCallMode")
V_DeleteImage = Uploader.Form("V_DeleteImage")
V_DeleteImage_Large = Uploader.Form("V_DeleteImage_Large")
V_DeleteFile = Uploader.Form("V_DeleteFile")
V_ID = Uploader.Form("V_ID")
V_Live = Uploader.Form("V_Live")
V_CodeNumber = Uploader.Form("V_CodeNumber")
V_Price = Uploader.Form("V_Price")
V_RRP = Uploader.Form("V_RRP")
V_Tax = Uploader.Form("V_Tax")
V_Weight = Uploader.Form("V_Weight")
V_DownLoadInfo = Uploader.Form("V_DownLoadInfo")
V_OrderByValue = Uploader.Form("V_OrderByValue")
V_FreeShipping = Uploader.Form("V_FreeShipping")
V_CustomerGroupID = NumSafe(Uploader.Form("V_CustomerGroupID"))
strStockTracking = Uploader.Form("strStockTracking")

If Not IsNumeric(V_OrderByValue) then V_OrderByValue = 0
If V_Live = "" Then V_Live = "n"

strDownloadExtension = Uploader.Form("strDownloadExtension")
strRandomFileName = Uploader.Form("strRandomFileName")

if V_Weight = "" then V_Weight=0
V_DeliveryTime = NumSafe(Uploader.Form("V_DeliveryTime"))
V_Quantity = NumSafe(Uploader.Form("V_Quantity"))
V_QuantityWarnLevel = NumSafe(Uploader.Form("V_QuantityWarnLevel"))

P_ID = NumSafe(Uploader.Form("P_ID"))

V_ProductID = P_ID

Dim V_Name(), V_Desc()
Redim V_Name(numTotalLanguages)
Redim V_Desc(numTotalLanguages)
For numCount = 1 to numTotalLanguages
	V_Name(numCount) = Uploader.Form("V_Name" & CStr(numCount))
	V_Desc(numCount) = Uploader.Form("V_Desc" & CStr(numCount))
next

V_Options = Uploader.Form("V_Options")

If strCallMode = "Delete" Then
	'User wants to delete this Version
	Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
	DeleteVersion V_ID, objFileSystem, Server.MapPath("default.asp"), Split(GetAppVar("allowedimages"), ",")
	Set objFileSystem = Nothing
	strErrorMsg = ""
Else
	'-------------------------------------------
	'CHECK FILE UPLOAD METHOD
	'-------------------------------------------
	'If a file was selected in the upload box
	If Uploader.Files.Exists("V_DownloadInfoUpload") Then
		'Get the upload name
		strFileUploadName = Uploader.Files("V_DownloadInfoUpload").FileName
		
		'If the name isn't blank, then get ready to upload the file
		If Not strFileUploadName = "" Then
			aryFileUploadName = Split(strFileUploadName, ".")
			strFileType = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
			strRandomFileName = GetRandomString(8)
			strUploadFileType = strFileType
			V_DownloadInfo = strFileType & "|" & strRandomFileName
			V_DownloadType = "u"
		'Otherwise, scrap all uploading plans
		Else
			V_DownloadType = "n"
			V_DownloadInfo = ""
		End If
	'No file was selected for upload.
	Else
		'If a file was previously uploaded
		If strDownloadExtension <> "" then
			'If it was decided to delete it
			If V_DeleteFile = "y" then
				'Change to link mode
				V_DownloadType = "l"

			'We're not deleting the file.
			Else
				'Decide whether to go link mode or 
				'stick with uploading
				If V_DownloadInfo <> "" then
					V_DownloadType = "l"
				Else
					V_DownloadType = "u"
					V_DownloadInfo = strDownloadExtension & "|" & strRandomFileName
				End If
			End If
		'No file was previously uploaded
		Else
			'Go to link mode
			V_DownloadType = "l"
		end if
	End If
	'If we're in linking mode but no link was entered,
	'go to 'nothing' mode
	If V_DownloadType = "l" and V_DownloadInfo = "" then
		V_DownloadType = "n"
	end if
	
	'If we're currently got an 'n' for downloadtype, check
	'to see if the freeshipping is checked. If it is, then
	'set downloadtype to f
	If V_DownloadType = "n" and V_FreeShipping = "y" then V_DownloadType = "f"

	'Check images for acceptable file types
	If Uploader.Files.Exists("V_Image") Then
		strFileUploadName = Uploader.Files("V_Image").FileName
		If Not strFileUploadName = "" Then
			aryFileUploadName = Split(strFileUploadName, ".")
			strFileType = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
		End If
		If Not Contains(GetAppVar("allowedimages"), strFileType) Then
			numErrorNo = numErrorNo + 1
			strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
		End If
	End If
	If Uploader.Files.Exists("V_Image_Large") Then
		strFileUploadName = Uploader.Files("V_Image_Large").FileName
		If Not strFileUploadName = "" Then
			aryFileUploadName = Split(strFileUploadName, ".")
			strFileType_Large = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
		End If
		If Not Contains(GetAppVar("allowedimages"), strFileType_Large) Then
			numErrorNo = numErrorNo + 1
			strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
		End If
	End If

	'-------------------------------------------
	'PERFORM REST OF ERROR CHECKING
	'-------------------------------------------
	strDownloadExtension = strDownloadExtension
	Dim aryDownloadExtension(0)
	aryDownloadExtension(0) = strDownloadExtension
	
	AllNamesBlank = true
	For numCount = 1 to numTotalLanguages
		'If it's live on the front, then it can't be blank
		If aryLangLiveFront(numCount) = "y" then
			AllNamesBlank = AllNamesBlank and V_Name(numCount) = ""
		end if
		
		'check them all for length
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_VersionName") & " " & CStr(numCount), V_Name(numCount), GetAppVar("V_Name_AL"))
		strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_Description") & " " & CStr(numCount), V_Desc(numCount), GetAppVar("V_Desc_AL"))
	next
	If AllNamesBlank then strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_VersionName"), "")
						
	strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_CodeNumer"), V_CodeNumber)
	strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_Product"), V_ProductID)
	strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_Price"), V_Price)

	strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_CodeNumer"), V_CodeNumber, GetAppVar("V_CodeNumber_AL"))
	strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_DownLoadURL"), V_DownloadURL, GetAppVar("V_DownloadURL_AL"))

	If Not IsNumeric(V_Price) Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkPriceIsNumeric") & "<br />"
	End if
	IF V_RRP = "" then V_RRP = 0
	If Not IsNumeric(V_RRP) Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkRRPIsNumeric") & "<br />"
	End if
	If Not IsNumeric(V_Weight) Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkWeightIsNumeric") & "<br />"
	End if

	strVersionCode = CheckVersionCode(V_CodeNumber, V_ID)
	If Not strVersionCode = "OK" Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkVIDCodeNumer") & " (" & V_CodeNumber & ") " & GetString("ContentText_ErrorChkVIDAlreadyInUse") & " " & strVersionCode & ". <br /><br /><span class=""small""><a href=""_modify_version.asp?" & objCactuSession.QS & "V_ID=" & strVersionCode & """ target=""_blank"">" & GetString("ContentText_ErrorChkVIDViewThatVersion") & "</a></span><br />"
	End if

	'If stock tracking turned on but they didn't set a warn level, error	
	If strStockTracking = "y" and V_QuantityWarnLevel = 0 Then
		numErrorNo = numErrorNo + 1
		strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorStockTrackingWarnLevel") & "<br />"
	End if


	
	'Error Checking Complete
	If strErrorMsg = "" Then
		'No problem with doing the database stuff
		'-----------------------------------------------
		'NEW VERSION
		'If V_ID is zero then it is a new version, in
		'this case we insert a new record into the DB
		'-----------------------------------------------
		If V_ID = 0 Then
			strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "Versions ("
			For numCount = 1 to numTotalLanguages
				If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & "V_Name" & CStr(numCount) & ", V_Desc" & CStr(numCount) & ", "
			next
			strQuery = strQuery & "V_CodeNumber, V_Price, V_Tax, V_Weight, V_Quantity, V_QuantityWarnLevel, V_DeliveryTime, V_DownloadInfo, V_DownloadType, V_ProductID, V_Live, V_OrderByValue, V_RRP, V_Type, V_CustomerGroupID) VALUES("
			For numCount = 1 to numTotalLanguages
				If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & strUnicode & "'" & SQLSafe(V_Name(numCount)) & "', " & strUnicode & "'" & SQLSafe(V_Desc(numCount)) & "', "
			next
			strQuery = strQuery & strUnicode & "'" &_
 				SQLSafe(V_CodeNumber) & "'," &_
				SQLDecimals(V_Price) & "," &_
				V_Tax & ", " &_
				V_Weight & "," &_
 				V_Quantity & "," &_
  				V_QuantityWarnLevel & "," &_				
 				V_DeliveryTime & ",'" &_
 				SQLSafe(V_DownloadInfo) & "','" &_
 				SQLSafe(V_DownloadType) & "'," &_
 				V_ProductID & ",'" &_
				SQLSafe(V_Live) & "'," &_
				V_OrderByValue & "," &_
				SQLDecimals(V_RRP) & ",'v'," &_
				V_CustomerGroupID & ")"
			Call ExecuteNonQuery(strQuery)

			'--------------------------------------------------
			'FIND ID OF NEW VERSION
			'--------------------------------------------------
			V_ID = ExecuteScalar("SELECT V_ID FROM tblCactuShop" & TABLE_PREFIX & "Versions WHERE V_CodeNumber = " & strUnicode & "'" & SQLSafe(V_CodeNumber) & "'")
		
		'-----------------------------------------------
		'UPDATE VERSION
		'Otherwise, update the version.
		'-----------------------------------------------
		Else
			strQuery="UPDATE tblCactuShop" & TABLE_PREFIX & "Versions SET "
			for numCount = 1 to numTotalLanguages
				If arylangliveback(numCount) = "y" then strQuery = strQuery & "V_Name" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(V_Name(numCount)) & "',V_Desc" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(V_Desc(numCount)) & "',"
			next
			strQuery = strQuery &_
				"V_CodeNumber=" & strUnicode & "'" & SQLSafe(V_CodeNumber) & "'," &_
				"V_Price=" & SQLDecimals(V_Price) & "," &_
				"V_Tax=" & V_Tax & "," &_
				"V_Weight=" & V_Weight & "," &_
				"V_DeliveryTime=" & V_DeliveryTime & "," &_
				"V_Quantity=" & V_Quantity & "," &_
				"V_QuantityWarnLevel=" & V_QuantityWarnLevel & "," &_			 			 			 
				"V_DownLoadInfo='" & SQLSafe(V_DownLoadInfo) & "'," &_
				"V_DownLoadType='" & SQLSafe(V_DownLoadType) & "'," &_
				"V_Live='" & SQLSafe(V_Live) & "'," &_
				"V_ProductID=" & V_ProductID & ", " &_
				"V_OrderByValue=" & V_OrderByValue & ", " &_
				"V_RRP=" & SQLDecimals(V_RRP) & "," &_
				"V_CustomerGroupID=" & V_CustomerGroupID & " WHERE V_ID=" & V_ID
			Call ExecuteNonQuery(strQuery)
		End If

		'Do the image management, if needed
		'Use Version ID + File Extension for name to avoid overwriting pre-existing images.
		Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
		If V_DeleteImage = "y" Or Uploader.Files.Exists("V_Image") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_versions/" & V_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
		If V_DeleteImage_Large = "y" Or Uploader.Files.Exists("V_Image_Large") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_versions_large/" & V_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
		If V_DeleteFile = "y" Or V_DownloadType <> "u" Or Uploader.Files.Exists("V_DownloadInfoUpload") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "files_versions/" & V_ID & "_" & strRandomFileName), aryDownloadExtension, objFileSystem
		Set objFileSystem = Nothing
		
		
		If Uploader.Files.Exists("V_DownloadInfoUpload") Then
			Uploader.Files("V_DownloadInfoUpload").FileName = V_ID & "_" & strRandomFileName & "." & strUploadFileType
			Uploader.Files("V_DownloadInfoUpload").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "files_versions/")
		End If
		If Uploader.Files.Exists("V_Image") Then
			Uploader.Files("V_Image").FileName = V_ID & "." & strFileType
			Uploader.Files("V_Image").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_versions/")
		End If
		If Uploader.Files.Exists("V_Image_Large") Then
			Uploader.Files("V_Image_Large").FileName = V_ID & "." & strFileType_Large
			Uploader.Files("V_Image_Large").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_versions_large/")
		End If
		
		'... and options ...
		VersionOptions V_ID, Split(V_Options, ", ")		
		
		If SOFTWARE_IS_PRO then
			Call ProcessBackendGroupPricing(V_ID)
		End If
		
		'-----------------------------------------------
		'QUANTITY DISCOUNT PRICES
		'-----------------------------------------------
		If SOFTWARE_IS_PRO Then
			UpdateQuantityPriceBreaks(V_ID)
		End If
	End If
End If
%>

<!--#include file="includes/back_productpage.asp"-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
</head>
<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
	<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="660">
<tr>
    <td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
    <td valign="top">
    <%= strProductHTML %>
    <table border="0" cellpadding="5" cellspacing="0" width="100%">
    <% if strErrorMsg <> "" then
		'Show errors %>
		<tr>
			<td><h1><% WriteString("PageTitle_Problems") %></h1></td>
		</tr>
		<tr>
			<td><% WriteString("ContentText_PleaseGoBackAndCorrect") %></td>
		</tr>
		<tr>
			<td><% =strErrorMsg %></td>
		</tr>	
		<tr>
			<td align="center"><a href="javascript:history.back()">&lt;&lt; <% WriteString("ContentText_BackLink") %></a></td>
		</tr>	 
	
	<% else
		'Tell the user all was good %>
		<tr>
			<td><h1><% WriteString("PageTitle_Updated") %></h1></td>
		</tr>		
		<tr>
			<td><% WriteString("ContentText_VersionUpdated") %></td>
		</tr>	
	
	<% end if %>
	
	</table></td>
	</tr>
</table>
</html>
<%
Call EndPage()
%>
