<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "1144, 1145, 1146, 1147, 1148, 1187, 1745" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/lockshop.asp"-->
<!--#include file="includes/initialize.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/customer_security.asp"-->
<!--#include file="includes/buildpage.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'ERROR HANDLER
'If any untrapped errors occur, then the user is 
'forwarded to this page. An email is sent off to 
'the store owner
'ID - the error that it relates to
'Page - the page that it occurred on
'-----------------------------------------------


'ERROR CODE LIST:
'nopaymentsystem		- no payment system was available to the user on checkout
'badshiptaxband			- the shipping tax band is incorrect
'badhandlingtaxband		- the order handling tax band is incorrect
'badshipping			- Shipping method doesn't exist
'badgateway				- Failed to create payment gateway class.							params: gateway
'badprocesscurrency		- The processing currency was invalid.								params: gateway, currency
'badcustomeroncheckout	- Bad customer id on checkoutcomplete.asp.							params: customer
'filenotfound			- Error occurred when trying to stream downloadable file to user.	params: version
'upsnotindb				- The type returned by UPS isn't in the db for lookup				params: code
'upsmeasurement			- UPS returns error 110546 - incorrect measurement type
'upsunhandled			- UPS returns unhandleded error										params: code
'upsunspecified			- UPS returns unspecified error
'nobaseversion			- No base version for a product with options found					params: product

'-----------------------------------------------
'READ PAGE TEMPLATE FROM FILE					
'-----------------------------------------------
Call ReadFromTemplate(strTemplateLocation, aryPageTemplate)

'-----------------------------------------------
'WRITE FIRST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(0))

'Send email to store owner
If GetAppVar("senderroremail") = "y" then
	strOwner = strOwner & GetString("Error_Header") & vbcrlf & vbcrlf
	strOwner = strOwner & GetString("Error_ErrorID") & request.QueryString("id") & vbcrlf
	strOwner = strOwner & "-----------------------------------------" & vbcrlf
	strOwner = strOwner & GetString("Error_PaymentQuerystring") & vbcrlf
	for each strItem in request.querystring
		If strItem <> "id" then
			strOwner = strOwner & " - " & strItem & " : " & request.querystring(strItem) & vbcrlf
		End If
	next
	
	strOwner = strOwner & "-----------------------------------------" & vbcrlf
	strOwner = strOwner & GetString("Error_ServerVariables") & vbcrlf
	for each strItem in request.ServerVariables
		strOwner = strOwner & strItem & " : " & request.ServerVariables(strItem) & vbcrlf
	next
	Call SendEMail(GetAppVar("emailmethod"), GetAppVar("mailserver"), strEmailTo, "", "", strEmailFrom, strEmailFrom, strEmailFrom, strEmailFrom, GetString("Config_Subjectline2") & " - " & GetString("Error_EmailSubjectLine"), strOwner, "", false)
end if
%>
<h1><% WriteString("PageTitle_Error") %></h1>
<div class="error">
	<p><% WriteString("ContentText_ErrorText") %></p>
</div>
<%
'-----------------------------------------------
'WRITE LAST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(1))

Call EndPage()
%>
