<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "18, 203, 204, 205, 206, 207, 208, 289, 290, 304, 889, 890, 891, 980, 981, 1010, 1588, 1711, 1881" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/lockshop.asp"-->
<!--#include file="includes/initialize.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/customer_security.asp"-->
<!--#include file="includes/buildpage.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'SET PAGETITLE TAG
'-----------------------------------------------
strPageTitleHTML = GetString("PageTitle_ShippingRates") & GetString("PageTitle_Separator") & GetString("Config_Webshopname")

'-----------------------------------------------
'SHIPPING PRICES DISPLAY
'This is switchable between using weight or
'order cost as the basis for calculating
'shipping prices.
'-----------------------------------------------

'Useful application variables
strAppCalcShipCostByWeight = GetAppVar("calcshipcostbyweight")
strAppPricesIncTax = GetAppVar("pricesinctax")
strAppShowTaxDisplay = GetAppVar("showtaxdisplay")

'-----------------------------------------------
'LOOKUP SHIPPING TAX RATE
'-----------------------------------------------
strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "TaxRates WHERE T_ID=" & NumSafe(GetAppVar("shiptaxband"))
Call ExecuteRS(strQuery, objRecordSet)
If objRecordSet.BOF and objRecordSet.EOF then
	objRecordSet.Close
	Call EndPage()
	response.Redirect("error.asp?" & strSessionQS & "ID=badshiptaxband")
else
	numTaxRate = objRecordSet("T_Taxrate")
	objRecordSet.close
end if

'-----------------------------------------------
'READ PAGE TEMPLATE FROM FILE					
'-----------------------------------------------
Call ReadFromTemplate(strTemplateLocation, aryPageTemplate)

'-----------------------------------------------
'WRITE FIRST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(0))

Function GetShippingValue(numValue, blnShowFreeMessage)
	If numValue = 0 then
		If blnShowFreeMessage then
			GetShippingValue = GetString("ContentText_Free")
		End If
	Else
		GetShippingValue = objCurrency.Display(numValue, true, false)
	End If
End Function 
%>
<h1><% WriteString("PageTitle_ShippingRates") %></h1>
<div class="shipping">
	<% 
	strAppShippingSystem = GetAppVar("shippingsystem")
	Select Case strAppShippingSystem 
		Case "ups" %>
			<p><% WriteString("ContentText_UPSExplanation") %></p>

		<% Case "none" %>
			<p><% WriteString("ContentText_ShippingDisabled") %></p>
		
		<% Case Else %>
			<p>(<%= IIf(strAppCalcShipCostByWeight = "y", GetString("ContentText_CalculatedByOrderWeight"), GetString("ContentText_CalculatedByOrderValue"))%>)</p><%
			
			'Set variables based on shipping calculation type
			If strAppCalcShipCostByWeight = "y" then
				strWeightDisplay = " " & GetAppVar("weightunit")
				strValueColumn = GetString("ContentText_OrderWeight")
			Else
				strWeightDisplay = ""
				strValueColumn = GetString("ContentText_OrderValue")
			End if
						
			'Pull out all shipping methods
			strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "ShippingMethods WHERE SM_Live='y' ORDER BY SM_OrderByValue ASC, SM_ID ASC"
			Call ExecuteRS(strQuery, objRecordSet)
			Do While not objRecordSet.EOF
				'Pull out shipping method details
				SM_ID = objRecordSet("SM_ID")
				SM_Name = objRecordSet("SM_Name" & numLanguageID)
				SM_Desc = objRecordSet("SM_Description" & numLanguageID)
				numLastZone = 0
				
				'Pull out shipping rates for this method
				strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "ShippingRates INNER JOIN tblCactuShop" & TABLE_PREFIX & "ShippingZones ON tblCactuShop" & TABLE_PREFIX & "ShippingRates.S_ShippingZoneID = tblCactuShop" & TABLE_PREFIX & "ShippingZones.SZ_ID WHERE S_ShippingMethodID = " & SM_ID & " ORDER BY SZ_OrderByValue, S_Boundary"
				Call ExecuteRS(strQuery, objRecordSet2)
				If Not (objRecordSet2.BOF and objRecordSet2.EOF) then
				
					'Display shipping method and open rates table %>
					<div class="shippingtable">
						<h2><%= SM_Name %></h2>
						<p><%= SM_Desc %></p>
						<table summary="<% WriteSafeString("ContentText_ShippingTableSummary") %>">
							<tr class="header">
								<th class="zone"></th>
								<th class="ordervalue"><%= strValueColumn %></th><%
								'Price headings
								If strAppPricesIncTax = "y" then
									'Prices inc tax
									If strAppShowTaxDisplay = "y" then %>
										<th class="price_1"><%= GetString("ContentText_Shipping") & " " & GetString("ContentText_ExTax") %></th>
										<th class="price_2"><%= GetString("ContentText_Shipping") & " " & GetString("ContentText_IncTax") %></th><%
									Else %>
										<th class="price" colspan="2"><% WriteString("ContentText_Shipping") %></th><%
									End if
								Else
									'Prices Ex Tax
									If strAppShowTaxDisplay = "y" then %>
										<th class="price_1"><%= GetString("ContentText_Shipping") & " " & GetString("ContentText_ExTax") %></th>
										<th class="price_2"><% WriteString("ContentText_Tax") %></th><%
									Else %>
										<th class="price" colspan="2"><% WriteString("ContentText_Shipping") %></th><%
									End if
								End if %>								
							</tr>
						</thead>
						<tbody><%
							numBgCount = 0
							do while not objRecordSet2.EOF 
								numBgCount = numBgCount + 1
								numShippingRate = objRecordSet2("S_ShippingRate") %>
								<tr<%= IIf(numBgCount mod 2 = 1, " class=""alt""", "") %>>
									<td class="zone"><%
										'If it's a new zone, write out the name
										If objRecordSet2("SZ_ID") <> numLastZone then
											numRateCount = 1
											response.write objRecordSet2("SZ_Name" & CStr(numLanguageID))
											numLastZone = objRecordSet2("SZ_ID")
										Else
											numRateCount = numRateCount + 1
										end if 
									%></td>
									<td class="ordervalue"><%
										'Is it not the upper-bound?
										if objRecordSet2("S_Boundary") <> 999999 then
											'Show the boundary - price max or weight
											if strAppCalcShipCostByWeight = "y" then
												response.write(objRecordSet2("S_Boundary") & strWeightDisplay)
											else
												response.write(objCurrency.Display(objRecordSet2("S_Boundary"), true, false)) 
											end if
										else
											'If this is the first, just show 'all orders'
											If numRateCount = 1 then
												WriteString("ContentText_AllOrders")
											Else
												WriteString("ContentText_AllHigherOrders")
											End If
										end if '// upper-bound
										%>
									</td>
									<%				
									If strAppPricesIncTax = "y" then
										'Prices Inc Tax
										If strAppShowTaxDisplay = "y" then 
											numExTaxShippingRate = Round(numShippingRate * (1/(1 + (numTaxrate/100))),2) %>
											<td class="price_1"><%= GetShippingValue(numExTaxShippingRate, false) %></td>
											<td class="price_2"><%= GetShippingValue(numShippingRate, true) %></td><%
										Else %>
											<td class="price" colspan="2"><%= GetShippingValue(numShippingRate, true) %></td><%
										End if '// tax display
									Else
										'Prices Ex Tax
										If strAppShowTaxDisplay = "y" then %>
											<td class="price_1"><%= GetShippingValue(numShippingRate, true) %></td>
											<td class="price_2"><%= IIf(numShippingRate = 0, "", numTaxrate & "%") %></td><%
										Else %>
											<td class="price" colspan="2"><%= GetShippingValue(numShippingRate, true) %></td><%
										End if '// tax display
									End if '// prices inc tax %>
								</tr><%
								objRecordSet2.moveNext
							loop %>
						</tbody>
					</table></div><%
				End If
				objRecordSet2.Close
				objRecordSet.MoveNext
			Loop
			objRecordSet.Close
				
	End Select '// shippingmethod is UPS/cactushop %>
</div>

<%
'-----------------------------------------------
'WRITE LAST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(1))
Call EndPage()
%>
