<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "359, 401, 402, 572, 573, 631, 632, 633, 585"
strThisBackPage = "products" 
Set Uploader = New FileUploader
Uploader.Upload()
%>
<!--#include file="includes/upload.asp"-->
<!--#include file="includes/config.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/functions_backend.asp"-->
<!--#include file="includes/back_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'COLLECT VALUES FROM FORM						
'-----------------------------------------------
strCallMode = Uploader.Form("strCallMode")

If strCallMode = "Delete" And Len(Uploader.Form("strHardDelete")) > 0 Then
	strCallMode = "strHardDelete"
ElseIf strCallMode = "Delete" And Len(Uploader.Form("strSoftDelete")) > 0 Then
	strCallMode = "strSoftDelete"
End If
CAT_ID = Uploader.Form("CAT_ID")

Select Case strCallMode
	Case "Add", "Modify"
		
		CAT_Live = Uploader.Form("CAT_Live")
		CAT_DeleteImage = Uploader.Form("CAT_DeleteImage")
		CAT_DeleteImage_Large = Uploader.Form("CAT_DeleteImage_Large")
		If Not CAT_Live = "y" Then CAT_Live = "n"
		CAT_ProductDisplayType = Uploader.Form("CAT_ProductDisplayType")
		CAT_SubCatDisplayType = Uploader.Form("CAT_SubCatDisplayType")
		CAT_OrderByValue = Uploader.Form("CAT_OrderByValue")
		If Not IsNumeric(CAT_OrderByValue) then CAT_OrderByValue = 0
		CAT_OrderProductsBy = Uploader.Form("CAT_OrderProductsBy")
		CAT_CustomerGroupID = NumSafe(Uploader.Form("CAT_CustomerGroupID"))
		
		Dim CAT_Name(), CAT_Desc()
		Redim CAT_Name(numTotalLanguages)
		Redim CAT_Desc(numTotalLanguages)
		For numCount = 1 to numTotalLanguages
			CAT_Name(numCount) = Uploader.Form("CAT_Name" & CStr(numCount))
			CAT_Desc(numCount) = Uploader.Form("CAT_Desc" & CStr(numCount))
		next
		
		strParentIDs = Uploader.Form("numParentIDs")
		
		'-------------------------------------------
		'CHECK FILE UPLOAD IS OK FILETYPE
		'-------------------------------------------
		If Uploader.Files.Exists("CAT_Image") Then
			strFileUploadName = Uploader.Files("CAT_Image").FileName
			If Not strFileUploadName = "" Then
				aryFileUploadName = Split(strFileUploadName, ".")
				strFileType = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
			End If
			If Not Contains(GetAppVar("allowedimages"), strFileType) Then
				numErrorNo = numErrorNo + 1
				strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
			End If
		End If
		If Uploader.Files.Exists("CAT_Image_Large") Then
			strFileUploadName = Uploader.Files("CAT_Image_Large").FileName
			If Not strFileUploadName = "" Then
				aryFileUploadName = Split(strFileUploadName, ".")
				strFileType_Large = LCase(aryFileUploadName(Ubound(aryFileUploadName)))
			End If
			If Not Contains(GetAppVar("allowedimages"), strFileType_Large) Then
				numErrorNo = numErrorNo + 1
				strErrorMsg = strErrorMsg + "<b>" + CStr(numErrorNo) + ".</b> " + GetString("ContentText_ErrorChkUploadFileType") & replace(GetAppVar("allowedimages"),",",", ") & ".<br />"
			End If
		End If

		'-----------------------------------------------
		'ERROR CHECKING									
		'-----------------------------------------------
		blnAllNamesBlank = true
		blnAllDescsBlank = true
		For numCount = 1 to numTotalLanguages
			'If it's live on the front, then it can't be blank
			If aryLangLiveFront(numCount) = "y" then
				blnAllNamesBlank = blnAllNamesBlank and CAT_Name(numCount) = ""
				blnAllDescsBlank = blnAllDescsBlank and CAT_Desc(numCount) = ""
			end if
			
			'Check them all for string length
			strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_CategoryName") & " " & cstr(numCount), CAT_Name(numCount), GetAppVar("CAT_Name_AL"))
			strErrorMsg = BackendCheckLength(strErrorMsg, numErrorNo, GetString("FormLabel_CategoryDescription") & " " & cstr(numCount), CAT_Desc(numCount), GetAppVar("CAT_Desc_AL"))
		next
		If blnAllNamesBlank then strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_CategoryName"), "")
		
		'Category description blank check - now an optional field. 
		'Uncomment here to make it a required field
		'If blnAllDescsBlank then strErrorMsg = BackendCheckBlank(strErrorMsg, numErrorNo, GetString("FormLabel_CategoryDescription"), "")
		
		If strErrorMsg = "" Then

			If CAT_ID = 0 Then 
				'Insert new category
				strQuery="INSERT INTO tblCactuShop" & TABLE_PREFIX & "Categories ("
				For numCount = 1 to numTotalLanguages
					If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & "CAT_Name" & CStr(numCount) & ", CAT_Desc" & CStr(numCount) & ", "
				next
				strQuery = strQuery & "CAT_ProductDisplayType, CAT_SubCatDisplayType, CAT_OrderByValue, CAT_OrderProductsBy, CAT_Live, CAT_CustomerGroupID) VALUES ("
				For numCount = 1 to numTotalLanguages
					If aryLangLiveBack(numCount) = "y" then strQuery = strQuery & strUnicode & "'" & SQLSafe(CAT_Name(numCount)) & "', " & strUnicode & "'" & SQLSafe(CAT_Desc(numCount)) & "', "
				next
				strQuery = strQuery & "'" &_
					SQLSafe(CAT_ProductDisplayType) & "','" &_
					SQLSafe(CAT_SubCatDisplayType) & "'," &_
					CAT_OrderByValue & ",'" &_
					SQLSafe(CAT_OrderProductsBy) & "','" &_
					SQLSafe(CAT_Live) & "'," &_
					CAT_CustomerGroupID & ")"

				Call ExecuteNonQuery(strQuery)
				
				'Find ID of the new category
				strQuery = "SELECT CAT_ID FROM tblCactuShop" & TABLE_PREFIX & "Categories WHERE CAT_Name" & CStr(numDefaultLanguage) & "=" & strUnicode & "'" & SQLSafe(CAT_Name(numDefaultLanguage)) & "' ORDER BY CAT_ID DESC"
				Call ExecuteRS(strQuery, objRecordSet)
				CAT_ID = objRecordSet("CAT_ID")
				objRecordSet.close

			Else
				'Delete category hierachy links - we'll recreate them
				strQuery = strDeleteStatementSyntax & " tblCactuShop" & TABLE_PREFIX & "CategoryHierachy WHERE CH_ChildID = " & CAT_ID
				Call ExecuteNonQuery(strQuery)
				
				'Update the category
				strQuery="UPDATE tblCactuShop" & TABLE_PREFIX & "Categories SET "
				for numCount = 1 to numTotalLanguages
					If arylangliveback(numCount) = "y" then strQuery = strQuery & "CAT_Name" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(CAT_Name(numCount)) & "', CAT_Desc" & CStr(numCount) & "=" & strUnicode & "'" & SQLSafe(CAT_Desc(numCount)) & "',"
				next
				strQuery = strQuery &_
					"CAT_ProductDisplayType='" & SQLSafe(CAT_ProductDisplayType) & "'," &_
					"CAT_SubCatDisplayType='" & SQLSafe(CAT_SubCatDisplayType) & "'," &_
					"CAT_OrderByValue=" & CAT_OrderByValue & "," &_
					"CAT_OrderProductsBy='" & SQLSafe(CAT_OrderProductsBy) & "'," &_
					"CAT_Live='" & SQLSafe(CAT_Live) & "'," &_
					"CAT_CustomerGroupID=" & CAT_CustomerGroupID & " WHERE CAT_ID=" & CAT_ID
				Call ExecuteNonQuery(strQuery)
			End If
			
			'Insert new category hierachy links
			strParentIDs = replace(strParentIDs, " ", "")
			aryParentIDs = Split(strParentIDs, ",")
			
			Set objHierarchy = server.CreateObject("Scripting.Dictionary")
			
			For Each strParentID in aryParentIDs
				numParentID = NumSafe(strParentID)
				If Not objHierarchy.Exists(numParentID) then
					objHierarchy.Add numParentID, numParentID
					If numParentID & "" = strParentID then
						strQuery = "INSERT INTO tblCactuShop" & TABLE_PREFIX & "CategoryHierachy (CH_ParentID, CH_ChildID) VALUES (" & numParentID & "," & CAT_ID & ")"
						Call ExecuteNonQuery(strQuery)
					End If
				End If
			Next

			'Do the image management, if needed
			'Use Prodtype ID + File Extension for name to avoid overwriting pre-existing images.
			Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
			If CAT_DeleteImage = "y" Or Uploader.Files.Exists("CAT_Image") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_categories/" & CAT_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
			If CAT_DeleteImage_Large = "y" Or Uploader.Files.Exists("CAT_Image_Large") Then DeleteFile Server.MapPath(GetAppVar("uploadsfolder") & "images_categories_large/" & CAT_ID), Split(GetAppVar("allowedimages"), ","), objFileSystem
			Set objFileSystem = Nothing
			If Uploader.Files.Exists("CAT_Image") Then
				Uploader.Files("CAT_Image").FileName = CAT_ID & "." & strFileType
				Uploader.Files("CAT_Image").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_categories/")
			End If
			If Uploader.Files.Exists("CAT_Image_Large") Then
				Uploader.Files("CAT_Image_Large").FileName = CAT_ID & "." & strFileType_Large
				Uploader.Files("CAT_Image_Large").SaveToDisk Server.MapPath(GetAppVar("uploadsfolder") & "images_categories_large/")
			End If

		End If
	Case Else
		'-----------------------------------------------
		'DELETES A CATEGORY
		'-----------------------------------------------
		If CAT_ID = 0 then 
			Call EndPage()
			response.redirect("default.asp?" & strSessionQS)
		end if
		If strErrorMsg = "" Then
			Set objFileSystem = Server.CreateObject("Scripting.FileSystemObject")
			Set objRecordSet2 = Server.CreateObject("ADODB.RecordSet")
			DeleteCategory CAT_ID, (strCallMode = "strHardDelete"), objFileSystem, objRecordSet, objRecordSet2
			Set objFileSystem = Nothing
			Set objRecordSet2 = Nothing
		End If
End Select

If strErrorMsg = "" Then
	'Redirect
	Call EndPage()
	Select Case strCallMode
		Case "Add", "Modify"
			Response.Redirect("_prodtype_back.asp?" & strSessionQS & "CAT_ID=" & CAT_ID)
		Case Else
			Response.Redirect("_default.asp?" & strSessionQS)
	end select
Else
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
	<head>
		<link rel="Bookmark" href="favicon.ico" />
		<link rel="SHORTCUT ICON" href="favicon.ico" />
		<link href="includes/backend.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<link href="includes/adminbar.css" rel="stylesheet" title="cactusoft" type="text/css" />
		<meta name="GENERATOR" content="www.cactusoft.com" />
		<!--
		===============================================================================
		CACTUSHOP v6.1 ASP SHOPPING CART
		1999-2007 CACTUSOFT INTERNATIONAL FZ-LLC. - WWW.CACTUSHOP.COM
		All rights reserved.
		===============================================================================
		-->
		<title><% =GetString("Config_headtitle") %></title>
	</head>
<body bgcolor="#FFFFFF" LEFTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
	<td colspan="2"><!--#include file="includes/back_header.asp"--></td>
</tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="660">
<tr>
    <td valign="top" width="190"><!--#include file="includes/back_menu.asp"--></td>
    <td valign="top"><table border="0" cellpadding="5" cellspacing="0" width="100%">
	<tr>
		<td><h1><% WriteString("PageTitle_Problems") %></h1></td>
	</tr>
	<tr>
		<td><% WriteString("ContentText_PleaseGoBackAndCorrect") %></td>
	</tr>
	<tr>
		<td><% =strErrorMsg %></td>
	</tr>	
	<tr>
		<td align="center"><a href="javascript:history.back()">&#171; <% WriteString("ContentText_BackLink") %></a></td>
	</tr>			
	</table></td>
</tr>
</table>
</div>
</html>
<% End If 
Call EndPage()
%>
