<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "14, 68, 73, 74, 99, 100, 101, 102, 122, 171, 211, 220, 243, 733, 1414, 1415, 1760, 1761, 1762, 1828, 1829" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/lockshop.asp"-->
<!--#include file="includes/initialize.asp"-->
<!--#include file="includes/functions.asp"-->
<%
'-----------------------------------------------
'SET PAGETITLE TAG
'-----------------------------------------------
strPageTitleHTML = GetString("PageTitle_MyAccount") & GetString("PageTitle_Separator") & GetString("Config_Webshopname")
strMustBeLoggedIn = GetAppVar("mustbeloggedin")

'-----------------------------------------------
'delete password from session. We do this before
'buildpage so customer_security.asp and buildpage
'knows that we're logged out.
'-----------------------------------------------
strLogout = ListSafe(request("strLogout"), "y", "")
If strLogout = "y" then
	objCactuSession.Delete "C_EmailAddress"
	objCactuSession.Delete "C_Password"
	
	objCactuSession.Delete "C_CardholderName"
	objCactuSession.Delete "C_CardholderCompany"
	objCactuSession.Delete "C_Card_Type"
	objCactuSession.Delete "numCardStartMonth"
	objCactuSession.Delete "numCardStartYear"
	objCactuSession.Delete "numCardExpiryMonth"
	objCactuSession.Delete "numCardExpiryYear"
	objCactuSession.Delete "C_CardholderStreetAddress"
	objCactuSession.Delete "C_CardholderTownCity"
	objCactuSession.Delete "C_CardholderCounty"
	objCactuSession.Delete "C_CardholderPostCode"
	
	objCactuSession.Delete "C_ShippingName"
	objCactuSession.Delete "C_ShippingCompany"
	objCactuSession.Delete "C_ShippingStreetAddress"
	objCactuSession.Delete "C_ShippingTownCity"
	objCactuSession.Delete "C_ShippingCounty"
	objCactuSession.Delete "C_ShippingPostCode"
	objCactuSession.Delete "C_Telephone"

	objCactuSession.Delete "strCustomerComments"
    
	objCactuSession.Delete "strSameShippingAsBilling"
End if

%>
<!--#include file="includes/customer_security.asp"-->
<!--#include file="includes/buildpage.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2008 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

strMessage = ListSafe(request("strMessage"), "noemail,nopassword,email,notfound", "")

'-----------------------------------------------
'READ PAGE TEMPLATE FROM FILE					
'-----------------------------------------------
Call ReadFromTemplate(strTemplateLocation, aryPageTemplate)

'-----------------------------------------------
'Get whether customer has to be logged in to see
'the site. If they do, then this page acts as
'the login page for teh whole site, so the page
'title and text change
'-----------------------------------------------
strAppMustBeLoggedIn = GetAppVar("mustbeloggedin")

IsMyAccount = "y" 'set here so we can tell when submitted to emailreminder whether to return with error to checkout or myaccount

'-----------------------------------------------
'WRITE FIRST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(0))
%>
<h1><%= IIf(strAppMustBeLoggedIn = "yes", GetString("PageTitle_LogInToSite"), GetString("PageTitle_MyAccount")) %></h1>

<div class="customer">
<% If strMessage <> "" then %>
	<div class="errors"><strong>
	<%
	'-----------------------------------------------
	'RETURNED BACK TO PAGE DUE TO AN ERROR			
	'-----------------------------------------------
	Select Case strMessage 
		Case "noemail"
			'email address is blank
			strMessageText = GetString("ContentText_NoEmailAddress")
		Case "nopassword"
			'password is blank
			strMessageText = GetString("ContentText_MustEnterPassword")
		Case "email"
			'email is not valid format
			strMessageText = Replace(GetString("ContentText_EmailAddressNotValid"), "<label>", GetString("FormLabel_EmailAddress")) & " " & strEmailFrom
		Case "notfound"
			'email/pw combination was not found
			strMessageText = GetString("ContentText_NoMatch")
	End Select
	response.Write strMessageText
	%>
	</strong></div>
<% end if %>

<p><%= IIf(strAppMustBeLoggedIn = "yes", GetString("ContentText_LogInToSite"), GetString("ContentText_PreviousOrder")) %></p>

<form method="post" action="c.asp"><div class="box inputform">

	<input type="hidden" name="strIsSubmitting" value="y" />
	<%= objCactuSession.Form %>
	<label for="C_EmailAddress"><% WriteString("FormLabel_EmailAddress") %></label>
	<div><input type="text" name="C_EmailAddress" id="C_EmailAddress" value="<%= WriteSafe(objCactuSession.Value("C_EmailAddress")) %>" /></div><br />
	
	<label for="C_Password"><% WriteString("ContentText_CustomerCode") %></label>
	<div><input type="password" name="C_Password" id="C_Password" /></div><br />
	
	<input class="submit" type="submit" name="submit" value="<% WriteSafeString("FormButton_LogMeIn") %>" />
</div></form>
<!--#include file="includes/emailreminderform.asp"-->
<div class="section">
	<h2><% WriteSafeString("ContentText_CreateAccount") %></h2>
	<p><% WriteSafeString("ContentText_CreateAccountExplanation") %></p>

	<%
	'Don't give link to create accounts
	'for 'mustbeloggedin' config setting set
	'to 'y' or 'browse' - no point having that
	'members security if anyone can create an
	'account

	Select Case strMustBeLoggedIn
	Case "yes" %>
	<% WriteSafeString("ContentText_ThisSiteIsMembersOnly") %>
	<% Case "browse" %>
	<% WriteSafeString("ContentText_ThisSiteIsMembersOnlyOrdering") %>
	<% Case else %>
	<p><a href="customer_modifycode.asp?strCallMode=new&<% =objCactuSession.QS %>"><% WriteSafeString("ContentText_CreateNewAccount") %></a></p>
	<% End Select %>
</div>
</div>
<%
'-----------------------------------------------
'WRITE LAST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(1))

Call EndPage()
%>
