<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "103, 51, 104, 105, 106" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/lockshop.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/customer_security.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'EMPTY THE BASKET
'This page just empties the basket, it does this
'by setting the strings of items and qty in the
'basket session to nothing.
'-----------------------------------------------

If len(DualRequest("btnNo")) > 0 then

	'User decided not to empty the basket - redirect back
	Call EndPage()
	Response.redirect("basket.asp?" & strSessionQS)

Elseif len(DualRequest("btnYes")) > 0 then

	'Delete session values
	objCactuSession.Delete "strItems"
	objCactuSession.Delete "strQuantities"
	objCactuSession.Delete "strOptionGroups"
	objCactuSession.Delete "strOptions"
	strItems = ""
	strQuantities = ""
	strOptionGroups = ""
	strOptions = ""

	blnShowWarning = False

Else
	blnShowWarning = True
End If

'-----------------------------------------------
'INITIALISE AND BUILDPAGE
'Initialise to create our now-empty basket, and 
'buildpage to show our empty basket
'-----------------------------------------------
%>
<!--#include file="includes/initialize.asp"-->
<!--#include file="includes/buildpage.asp"-->
<%

'-----------------------------------------------
'READ PAGE TEMPLATE FROM FILE					
'-----------------------------------------------
Call ReadFromTemplate(strTemplateLocation, aryPageTemplate)

'-----------------------------------------------
'WRITE FIRST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(0))
%>
<div class="emptybasket">

	<h1><% WriteString("PageTitle_ShoppingBasket") %></h1>

	<% If blnShowWarning = True then %>
		<p><% WriteString("ContentText_EmptyShoppingBasketConfirm") %></p>
	
		<form action="emptybasket.asp" method="get" name="emptybasket" id="frmEmptyBasket">
		<div class="links">
			<%= objCactuSession.Form %>
			<input class="submit" type="submit" name="btnYes" value="<% WriteSafeString("ContentText_Yes") %>" /><input class="submit" type="submit" name="btnNo" value="<% WriteSafeString("ContentText_No") %>" />
		</div>
		</form>
	<% else %>
		<p><% WriteString("ContentText_BasketEmptied") %></p>
	<% end if %>

</div>
<%
'-----------------------------------------------
'WRITE LAST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(1))

Call EndPage()
%>
