<!-- #include file="classes.asp"-->
<%
'===============================================
' CactuShop ASP Shopping Cart
' 1999-2006 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================


'**************************************************************************
'CACTUSHOP v6 CONFIG FILE - READ THIS FIRST!
' This defines a few configuration settings. You need to set up the following
'
'	1 - Set license number 
'	2 - Database Connection
'
' The following can also be set here if required.
'
'	1 - Set your own developer license code
'	2 - Set an IP lock for the backend	
'	3 - Enable execution statistics (for non-live only!)
'	4 - Set your encryption key (if using CactuShop Encrypted Mail)
'	5 - A table prefix if you're running multiple stores on one database
'
' All other settings can be done through the backend.
'**************************************************************************

'Leave these!
session.LCID = 1033					'local identifier - CactuShop is designed to run on US defaults, leave this setting intact
numScriptExecutionStartTime = Timer	'Starts the script execution timer


'-----------------------------------------------
'CACTUSHOP LICENSE NUMBER
'The license number given to you when you
'received your copy of CactuShop must be entered
'below, within the double quotes:

CONST LICENSENUMBER = "XXXXXXXX-P0000-001"

'This is a license requirement - to run
'CactuShop without the valid license number, or
'to run more than one copy of CactuShop with the
'same license number is a copyright violation
'and a breach of the software license.
'-----------------------------------------------


'-----------------------------------------------
'DATABASE CONNECTION SETTINGS
'Uncomment (remove the ' at the start of the 
'line) the database type you are using, and 
'comment up the other two.
'Depending on which database you are using,
'uncomment the connection string and enter in
'the connection details. See the Quick Setup
'Guide and the manual for more information
'-----------------------------------------------
'Database type - access, sql or mysql
'CONST strDatabaseType = "mysql"
'CONST strDatabaseType = "mssql"
CONST strDatabaseType = "access"

' ----------------------- MySQL ODBC Connection String -------------------------
'CONST strDataSourceName = "DRIVER={MySQL ODBC 3.51 Driver};SERVER=yourserver;DATABASE=cactushop6;USER=username;PASSWORD=password;OPTION=3;"
'CONST strDataSourceName = "DRIVER={MySQL};SERVER=yourserver;DATABASE=cactushop6;USER=username;PASSWORD=password;OPTION=3;"

' ----------------------- MS SQLServer Connection String -----------------------
' (for connecting on port 1433 - the standard port for SQL Server)
'CONST strDataSourceName="Provider=sqloledb;Data Source=yourserver,1433;Network Library=DBMSSOCN;Initial Catalog=cactushop6;User ID=username;Password=password;"
'CONST strDataSourceName="Provider=sqloledb;Data Source=yourserver,1433;Network Library=DBMSSOCN;Initial Catalog=cactushop6;Trusted_Connection=yes;"

'------------------------MS SQLServer 2005 Connection String--------------------
'CONST strDataSourceName="Provider=SQLNCLI;Server=yourserver;Database=cactushop6;UID=username;PWD=@password;" 


' ----------------------- MSDE Connection String -------------------------------
'CONST strDataSourceName = "Provider=SQLOLEDB.1;Initial Catalog=cactushop6;Data Source=sql.yourhost.com;User ID=username;Password=password;"

' ----------------------- MS Access OLEDB Connection String --------------------
strPathToDatabase = "database/cactushop6.mdb" 'WE ADVISE TO CHANGE THIS OR TURN OFF READ ACCESS TO THIS FOLDER
strDatabasePassword = ""
strDataSourceName = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Server.MapPath(strPathToDatabase) & ";Jet OLEDB:Database Password=" & strDatabasePassword



'-----------------------------------------------
'DEVELOPER LICENSE
'If you are a developer you can include your own
'license or copyright notice at the top of all
'the pages (it will appear underneath the 
'cactushop license) by editing this setting
'-----------------------------------------------
CONST DEVELOPERLICENSE = "MYDEVLICNUM"


'-----------------------------------------------
'BACKEND IP LOCK
'With this you can lock access to the backend
'through only one IP or IP range. If you have
'a static IP, then set this to exactly your IP.
'Access to the backend will only be granted to
'that IP. If you have a dynamic IP, you can 
'enter your ISPs IP range to lock access to these.
'To do this, enter the IP block (e.g. "212.132")
'ONLY SET THIS IF YOU KNOW WHAT YOU ARE DOING!
'See the manual for more information on this 
'before you go playing around with it.
'-----------------------------------------------
CONST BACKEND_IP_LOCK = ""


'-----------------------------------------------
'EXECUTION STATISTICS
'Set whether to show execution stats. Only turn 
'this on while testing!
'-----------------------------------------------
blnShowDebugStats = false
blnShowDebugStatsQueries = false

'-----------------------------------------------
'TABLE PREFIX
'If you need to run multiple cactushop on one 
'database, you can add in a table prefix and rename
'your tables. This comes after the 'tblCactuShop" & TABLE_PREFIX & "'.
'e.g., a table prefix of '1' would have tables:
'tblCactuShop" & TABLE_PREFIX & "1AdminLog
'tblCactuShop" & TABLE_PREFIX & "1AffiliateLog
'-----------------------------------------------
CONST TABLE_PREFIX = "1"

%>
<!--#include file="config_init.asp"-->