<%@ LANGUAGE="VBSCRIPT" %>
<% PageStrings = "14, 33, 74, 102, 169, 176, 179, 228, 291, 728, 729, 730, 731, 732, 733, 734, 735, 736, 737, 738, 739, 740, 741, 742, 743, 744, 751, 752, 754, 755, 756, 757, 758, 759, 760, 761, 762, 763, 764, 766, 767, 768, 769, 770, 771, 772, 773, 774, 775, 776, 777, 778, 779, 795, 796, 797, 885, 1759" %>
<!--#include file="includes/config.asp"-->
<!--#include file="includes/lockshop.asp"-->
<!--#include file="includes/initialize.asp"-->
<!--#include file="includes/functions.asp"-->
<!--#include file="includes/customer_security.asp"-->
<%
If GetAppVar("enablewishlist") = "n" then
	server.transfer("sitemap.asp")
End if

'-----------------------------------------------
'SET PAGETITLE TAG
'-----------------------------------------------
strPageTitleHTML = GetString("PageTitle_WishListLogin") & GetString("PageTitle_Separator") & GetString("Config_Webshopname")

'===============================================
' CactuShop ASP Shopping Cart
' 1999-2007 Cactusoft International FZ-LLC
' www.cactusoft.com
'===============================================
' All rights reserved.							
' Use of this code is covered by the terms and	
' conditions in the license agreement. No		
' unauthorized duplication or distribution is	
' permitted. Cactusoft's copyright notices must	
' remain in the ASP sections of the code.		
'===============================================

'-----------------------------------------------
'WISHLIST
'-----------------------------------------------
strCallMode = ListSafe(DualRequest("strCallMode"), "login,recoverpublic,recoverprivate,logout", "login")
strProblem = ""

'Login attempt with public password
strWishListEmail = DualRequest("strWishListEmail")
strPassword = DualRequest("strPassword")

'If we've got no details, get from session
If strWishListEmail = "" and strPassword = "" then
	strWishListEmail = objCactuSession.Value("strWishListEmail")
	strPassword = objCactuSession.Value("WL_Password")
End if

'If we're got login information and currently doing login, try doing recovery
If strCallMode = "login" and strWishListEmail <> "" and strPassword <> "" then
	strCallMode = "recoverpublic"
End If

'-----------------------------------------------
'WHAT WISHLIST TASK TO PERFORM?
'-----------------------------------------------
Select Case strCallMode 
	Case "logout"
		'Log out and display login form
		objCactuSession.Edit "WL_ID", ""
		objCactuSession.Edit "strWishListEmail", ""
		objCactuSession.Edit "WL_Password", ""
		strCallMode = "login"
	
	Case "recoverprivate"
		'Try and pull out the wishlist which matches the customer we're logged in as
		WL_ID = NumSafe(request.QueryString("WL_ID"))
		strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "WishList INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "WishList.WL_CustomerID = tblCactuShop1Customers.C_ID WHERE WL_ID=" & WL_ID & " AND WL_CustomerID=" & NumSafe(DB_C_ID)
		Call ExecuteRS(strQuery, objRecordSet)
		If Not (objRecordSet.BOF and objRecordSet.EOF) then
			strCallMode = "private"
		Else
			objRecordSet.Close
			strProblem = "publicnotfound"
		End If

	Case "recoverpublic"
		
		'If we haven't got details, throw error
		If strWishListEmail = "" then 
			strProblem = "publicnoemail" 
		ElseIf strPassword = "" then 
			strProblem = "publicnopassword" 
		Else
			'Check database for wishlist
			strQuery = "SELECT * FROM tblCactuShop" & TABLE_PREFIX & "WishList INNER JOIN tblCactuShop" & TABLE_PREFIX & "Customers ON tblCactuShop" & TABLE_PREFIX & "WishList.WL_CustomerID = tblCactuShop1Customers.C_ID WHERE C_EmailAddress='" & SQLSafe(strWishListEmail) & "' AND WL_PublicPassword = '" & SQLSafe(strPassword) & "'"
			Call ExecuteRS(strQuery, objRecordSet)
			If Not (objRecordSet.BOF and objRecordSet.EOF) then
				'Check case sensitivity on password
				If objRecordSet("WL_PublicPassword") = strPassword then
					'Details good - show and store details in form
					strCallMode = "public"
					objCactuSession.Edit "strWishListEmail", strWishListEmail
					objCactuSession.Edit "WL_Password", strPassword
				Else
					objRecordSet.Close
					strProblem = "publicnotfound"
				End If
			else
				objRecordSet.Close
				strProblem = "publicnotfound"
			end if
		End If
End Select

'If we're got an error, show the login form
If strProblem <> "" then strCallMode = "login" 

%>
<!--#include file="includes/buildpage.asp"--><%

'-----------------------------------------------
'READ PAGE TEMPLATE FROM FILE
'-----------------------------------------------
Call ReadFromTemplate(strTemplateLocation, aryPageTemplate)

'-----------------------------------------------
'WRITE FIRST HALF OF PAGE HTML
'-----------------------------------------------
response.write(aryPageTemplate(0)) %>

<h1><% WriteString("PageTitle_WishListLogin") %></h1>
<div class="wishlist"><%
	
	If strCallMode <> "login" then
			
		'Get wishlist details from db
		WL_OwnerName = objRecordSet("WL_OwnerName")
		WL_Name = objRecordSet("WL_Name")
		WL_Message = objRecordSet("WL_Message")
		
		'Create the two baskets
		Set objWishlist = New Basket: Set objOrigWishlist = New Basket
		objWishlist.Load objRecordSet("WL_Items"), objRecordSet("WL_Quantity"), objRecordSet("WL_OptionGroups"), objRecordSet("WL_Options")
		objOrigWishlist.Load objRecordSet("WL_OrigItems"), objRecordSet("WL_OrigQuantity"), objRecordSet("WL_OrigOptionGroups"), objRecordSet("WL_OrigOptions")
		objRecordSet.Close 
		Call objOrigWishList.Validate(objRecordSet, true) %>
		
		<div class="section">
			<h2><% WriteString("PageTitle_WishListFor") %>&nbsp;<%= WriteSafe(WL_OwnerName) %></h2>
			<p><%= WriteSafe(WL_Message) %></p>
			<p><% WriteString("ContentText_WishListForDesc") %></p>	
			<table>
				<tr class="header">
					<th><% WriteString("ContentText_Item") %></th>
					<th><% WriteString("ContentText_Status") %></th>
				</tr><%
				For i = 0 to objOrigWishlist.Count - 1
					With objOrigWishlist.Item(i) 
						'Does it exist in the the reduced basket? If so, there's still some to buy
						blnStillRequired = objWishList.Exists(.m_versionID, .OptionsList) 
						If blnStillRequired then 
							strStillRequired = objWishList.Version(.m_versionID, .OptionsList).Quantity 
							If strCallMode = "private" then strStillRequired = strStillRequired & "/" & .Quantity
						End If %>
						<tr<%= IIf(i mod 2 = 0, "", " class=""alt""") %>>
							<td><a href="product.asp?<%= objCactuSession.QS %><%= .GetLinkQS %>strPageHistory=wishlist"><%= .ProductName %></a><br /><%
							if .HasOptions Then 
								Response.Write .OptionText("html")
							else
								response.Write .VersionName
							end if %></td><%
								
							If Not blnStillRequired then %>
								<td><% WriteString("ContentText_AllRequiredPurchased") %></td><%
							else %>
								<td><%= strStillRequired %>&nbsp;<% WriteString("ContentText_StillRequired") %></td><%
							end if %>
						</tr><%
					End With
				next %>	
			</table><%
			
			'Show logout link if we're logged in as public
			If strCallMode = "public" then %>
				<p><% WriteString("ContentText_ToLogOutOfWishList") %>&nbsp;<a href="wishlist.asp?<%= objCactuSession.QS %>strCallMode=logout"><% WriteString("ContentText_WishListClickHere") %></a></p><%
			End If %>
		</div><%

	Else
		If strProblem <> "" then %>
			<div class="errors"><strong><%
				'Displa error message
				Select Case strProblem 
					Case "publicnotfound"
						'Wish list not found for this user
						strProblemText = GetString("ContentText_WishListNotFound")
					Case "publicnoemail"
						'Wish list submission missing required data
						strProblemText = GetString("ContentText_NoEmailForWishList")
					Case "publicnopassword"
						'Wish list submission missing required data
						strProblemText = GetString("ContentText_MustEnterPassword")
				End Select
				response.Write strProblemText %>
			</strong></div><%
		end if %>
		<div class="section">			
			<h2><% WriteString("ContentText_SeeFriendsWishList") %></h2>
			<form method="post" action="wishlist.asp"><div class="inputform">
				<%= objCactuSession.Form %>
				<input type="hidden" name="strCallMode" value="recoverpublic" />
				<p><% WriteString("ContentText_SeeFriendsWishList2") %></p>
			
				<label for="strWishListEmail"><% WriteString("ContentText_WishListEmail") %></label>
				<div><input type="text" name="strWishListEmail" id="strWishListEmail" value="<%= WriteSafe(strWishListEmail) %>" /></div><br />
				
				<label for="strPassword"><% WriteString("ContentText_WishListPassword") %></label>
				<div><input type="password" name="strPassword" id="strPassword" /></div><br />
								
				<input class="submit" type="submit" name="submit" value="<% WriteSafeString("FormButton_LogMeIn") %>" />
			</div></form>
		</div><%
	End If %>
</div><%

'-----------------------------------------------
'WRITE LAST HALF OF PAGE HTML					
'-----------------------------------------------
response.write(aryPageTemplate(1))
Call EndPage()
%>
